-- by "Marhu" 
-- v 1.0
-- Date: 16.06.2013
--"erweitert den PlacementScreen um ein paar Funktionen"


enhancedPlace = {};

function enhancedPlace:loadMap(name)
	self.lastY = 0;
	self.FixDir = 0;
	self.FixGrid = 0;
	self.YDif = 0;
end;
function enhancedPlace:deleteMap()
end;
function enhancedPlace:mouseEvent(posX, posY, isDown, isUp, button)
end;
function enhancedPlace:keyEvent(unicode, sym, modifier, isDown)
end;
function enhancedPlace:update(dt)

	if self.show then
		local t = g_gui.guis.PlacementScreen.target
		if not t.isSellMode then
			if InputBinding.hasEvent(InputBinding.enhancedPlace_RAUF) then
				self.FixDir = self.FixDir + 5
				if self.FixDir >= 90 then self.FixDir = 90 end;
				t.placeableRotY = self.lastY
				self.YDif = 0
			elseif InputBinding.hasEvent(InputBinding.enhancedPlace_RUNTER) then
				self.FixDir = self.FixDir - 5
				if self.FixDir <= 0 then self.FixDir = 0 end;
				t.placeableRotY = self.lastY
				self.YDif = 0
			elseif InputBinding.isPressed(InputBinding.enhancedPlace_FASTER)  then
				t.placeableRotationSpeed = t.placeableRotationSpeed + 0.00001
				if t.placeableRotationSpeed >= 0.006 then
					t.placeableRotationSpeed = 0.006
				end
			elseif InputBinding.isPressed(InputBinding.enhancedPlace_SLOWER)  then
				t.placeableRotationSpeed = t.placeableRotationSpeed - 0.00001
				if t.placeableRotationSpeed <= 0.00001 then
					t.placeableRotationSpeed = 0.00001
				end
			elseif InputBinding.hasEvent(InputBinding.enhancedPlace_GRIDUP) then
				if self.FixGrid > .9 then
					self.FixGrid = self.FixGrid + 1
				else
					self.FixGrid = self.FixGrid + .1
				end
				if self.FixGrid >= 10 then self.FixGrid = 10 end;
			elseif InputBinding.hasEvent(InputBinding.enhancedPlace_GRIDDOWN) then
				if self.FixGrid > 1 then
					self.FixGrid = self.FixGrid - 1
				else
					self.FixGrid = self.FixGrid - .1
				end
				if self.FixGrid <= 0 then self.FixGrid = 0 end;
			elseif InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
				self.HiddeTest = not self.HiddeTest;
			end
			
			if self.FixDir > 0 then
				if t.placeableRotY ~= self.lastY then
					self.YDif = self.YDif + t.placeableRotY - self.lastY;
					t.placeableRotY = self.lastY;
					if math.abs(self.YDif) >= math.rad(self.FixDir) then
						if self.YDif > 0 then
							t.placeableRotY = t.placeableRotY + math.rad(self.FixDir);
						else
							t.placeableRotY = t.placeableRotY - math.rad(self.FixDir);
						end;
						self.lastY = t.placeableRotY;
						self.YDif = 0;
					end;
					local x,y,z = getRotation(t.placeable.nodeId);
					setRotation(t.placeable.nodeId, x, t.placeableRotY, z);
				end;
			end;		
			
			local x,y,z = getTranslation(t.placeable.nodeId);
			if self.FixGrid > 0 then
				x2 = x/self.FixGrid;
				x =  math.floor(x2)*self.FixGrid
				z2 = z/self.FixGrid;
				z =  math.floor(z2)*self.FixGrid
				setTranslation(t.placeable.nodeId, x, y, z);
			end;	
			
			local textY = 0.95;
			local textH = 0.022;
			local r, g, b = 1, 1, 1;
			if self.HiddeTest then
				r, g, b = 1, 1, .5;
			end
			setTextBold(true);
			
			text = InputBinding.getKeyNamesOfDigitalAction(InputBinding.enhancedPlace_FASTER).." "..g_i18n:getText("enhancedPlace_FASTER");
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - textH
			text = InputBinding.getKeyNamesOfDigitalAction(InputBinding.enhancedPlace_SLOWER).." "..g_i18n:getText("enhancedPlace_SLOWER");
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - textH
			
			text = g_i18n:getText("enhancedPlace_speed")..string.format(" %.5f",t.placeableRotationSpeed)
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - (textH * 2)
			
			text = InputBinding.getKeyNamesOfDigitalAction(InputBinding.enhancedPlace_RAUF).." "..g_i18n:getText("enhancedPlace_RAUF");
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - textH
			text = InputBinding.getKeyNamesOfDigitalAction(InputBinding.enhancedPlace_RUNTER).." "..g_i18n:getText("enhancedPlace_RUNTER");
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - textH
			
			text = g_i18n:getText("enhancedPlace_fix_angle")..string.format(" %d",self.FixDir)
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - (textH * 2)
			
			text = InputBinding.getKeyNamesOfDigitalAction(InputBinding.enhancedPlace_GRIDUP).." "..g_i18n:getText("enhancedPlace_GRIDUP");
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - textH
			text = InputBinding.getKeyNamesOfDigitalAction(InputBinding.enhancedPlace_GRIDDOWN).." "..g_i18n:getText("enhancedPlace_GRIDDOWN");
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - textH
			
			text = g_i18n:getText("enhancedPlace_gridspacing")..string.format(" %.1f",self.FixGrid)
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - (textH * 2)
			
			text = g_i18n:getText("enhancedPlace_current_angle")..string.format(" %.3f",math.deg(t.placeableRotY) % 360);
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - (textH * 2)
			text = string.format("X: %.2f Y: %.2f Z: %.2f",x,y,z);
			setTextColor(0, 0, 0, 0.75);
			renderText(0.01, textY-0.0025, textH, text);
			setTextColor(r, g, b, 1);
			renderText(0.01, textY, textH, text)
			textY = textY - (textH * 2)	
			
			setTextColor(1,1,1,1);
			setTextBold(false);
		end;
	end;
	
	if not self.Hook then
		if g_gui.guis.PlacementScreen.onOpenCallback ~= nil then
			local orgonOpenCallback = g_gui.guis.PlacementScreen.onOpenCallback;
			g_gui.guis.PlacementScreen.onOpenCallback = function(a, b)
				orgonOpenCallback(a, b);
				a.placeableRotationSpeed = 0.003;
				enhancedPlace.lastY = 0;
				enhancedPlace.FixDir = 0;
				enhancedPlace.FixGrid = 0;
				enhancedPlace.YDif = 0;
				enhancedPlace.HiddeTest = nil;
				if not a.isSellMode then
					enhancedPlace.show = true;
				end;
			end;
			self.Hook = true;
		end;
		if g_gui.guis.PlacementScreen.onCloseCallback ~= nil then
			local orgonCloseCallback = g_gui.guis.PlacementScreen.onCloseCallback;
			g_gui.guis.PlacementScreen.onCloseCallback = function(a, b)
				orgonCloseCallback(a, b);
				enhancedPlace.show = nil;
			end;
		end;
		if PlacementScreen.isInsidePlacementPlaces ~= nil then
			local orgisInsidePlacementPlaces = PlacementScreen.isInsidePlacementPlaces;
			PlacementScreen.isInsidePlacementPlaces = function(a, b, c ,d ,e)
				local ra  = orgisInsidePlacementPlaces(a, b, c, d, e);
				if enhancedPlace.HiddeTest then
					return false;
				else
					return ra;
				end;
			end;
		end;
		if PlacementScreen.hasObjectOverlap ~= nil then
			local orghasObjectOverlap = PlacementScreen.hasObjectOverlap;
			PlacementScreen.hasObjectOverlap = function(a, b ,c ,d ,e)
				local ra  = orghasObjectOverlap(a, b, c, d, e);
				if enhancedPlace.HiddeTest then
					return nil;
				else
					return ra;
				end;
			end;
		end;
	end;
end;

function enhancedPlace:draw()
end;

addModEventListener(enhancedPlace);

